Index: /trunk/docs/services/debug.txt
===================================================================
--- /trunk/docs/services/debug.txt	(revision 405)
+++ /trunk/docs/services/debug.txt	(revision 406)
@@ -3,4 +3,7 @@
 How To Debug ZOO Services
 =========================
+
+:Authors: Luca Delucchi
+:Last Updated: $Date: 2013-03-27 00:06:12 +0100 (Wed, 27 Mar 2013) $
 
 There are different ways to debug your services, the most used solutions are via web
@@ -32,4 +35,19 @@
   sys.stderr.write("My message")
 
+.. _web_javascript:
+
+Javascript
+************
+
+You can user ``alert`` to print a string to the standard error.
+
+.. code-block:: javascript
+
+  // add this line when you want see your message
+  alert('My message')
+  // you can debug value of inputs, outputs or conf
+  alert(inputs["S"]["value"])
+
+.. note:: If you try to pass an object it return only ``[object Object]``
 
 Command line
@@ -73,2 +91,7 @@
   # add this line when you want investigate more in the code
   pdb.set_trace()
+
+Javascript
+************
+
+You can use ``alert`` also to print in the console, more info in the :ref:`web_javascript` web section
Index: /trunk/docs/services/howtos.txt
===================================================================
--- /trunk/docs/services/howtos.txt	(revision 405)
+++ /trunk/docs/services/howtos.txt	(revision 406)
@@ -4,5 +4,5 @@
 =========================
 
-:Authors: Nicolas Bozon, Gérald Fenoy, Jeff McKenna
+:Authors: Nicolas Bozon, Gérald Fenoy, Jeff McKenna, Luca Delucchi
 :Last Updated: $Date$
 
@@ -19,4 +19,7 @@
 ----------------------
 
+The function of the process for each programming language take three arguments: the main
+configuration, inputs and outputs.
+
 .. Note:: The service has to **return 3 if the process run successfully instead it 
 	  return 4** if the process end with an error.
@@ -40,13 +43,11 @@
     Python 
 serviceProvider
-    The name of the Python module to use as a ZOO Service Provider. For instance, if your 
-    script, located in the same directory as your ZOO Kernel, was named ``my_module.py`` then 
-    you should use ``my_module`` (the Python module name) for the serviceProvider value in ZCFG file. 
+    The name of the Python module to use as a ZOO Service Provider. For instance, if your
+    script, located in the same directory as your ZOO Kernel, was named ``my_module.py`` then
+    you should use ``my_module`` (the Python module name) for the serviceProvider value in ZCFG file.
 
 Python Data Structure used
 **************************
-
-The Python module's function to be used take three arguments: the main configuration, inputs and outputs.
-All this values are passed to the Python module as dictionaries.
+The three parameters of the function are passed to the Python module as dictionaries.
 
 Following you'll find an example for each parameters
@@ -184,4 +185,36 @@
 ----------
 
+ZOO API
+*********
+
+If you need to use :ref:`ZOO API <api>` in your service, you have first to copy ``zoo-api.js``
+and ``zoo-proj4js.js`` where your services are located (for example in Unix system probably in
+``/usr/lib/cgi-bin/``
+
+Javascript ZCFG requirements
+**********************************
+
+.. Note:: For each Service provided by your ZOO Javascript Services Provider, the ZCFG File 
+          must be named the same as the Javascript function name (also the case of
+          characters is important).
+
+The ZCFG file should contain the following :
+
+serviceType
+    JS 
+serviceProvider
+    The name of the JavaScript file to use as a ZOO Service Provider. For instance, if your
+    script, located in the same directory as your ZOO Kernel, was named ``my_module.js`` then
+    you should use ``my_module.js``.
+
+
+Javascript Data Structure used
+********************************
+
+The three parameters of the function are passed to the JavaScript function as Object.
+
+Sample ZOO Javascript Services Provider
+******************************************
+
 .. code-block:: javascript
 
@@ -192,2 +225,3 @@
      return Array(3,outputs);
   }
+